#!/bin/bash
kernels="xenomai4!kona!rt"
module="kona"
ret=$(yad --form --center --no-wrap --title="高音質カーネルインストーラー" --image="/usr/share/icons/Adwaita/32x32/emblems/emblem-system-symbolic.symbolic.png" --text="高音質カーネルをインストールする\n\n rt ... debianリアルタイムカーネル\n xenomai4 ... xenomai4カーネル\n kona ... Kona高音質カーネル\n"  --field="カーネル:CB" "$module!$kernels")
if [ "$?" = "0" ]; then
  kernelname="$(echo $ret|cut -d'|' -f1)"
  if [ "$kernelname" = "xenomai" ]; then
    kernel="linux-image-5.4.239-xenomai-kona"
  elif [ "$kernelname" = "xenomai4" ]; then
    kernel="linux-image-6.5.0-xenomai4-kona"
  elif [ "$kernelname" = "ck1" ]; then
    kernel="linux-image-5.12.0-ck1-kona"
  elif [ "$kernelname" = "pf" ]; then
    kernel="linux-image-6.4.0-pf3-pf-kona"
  elif [ "$kernelname" = "rt" ]; then
    kernel="linux-image-6.1.37-rt13-rc1-kona"
  elif [ "$kernelname" = "kona" ]; then
    kernel="linux-image-6.1.67-kona"
  elif [ "$kernelname" = "liquorix" ]; then
    kernel="linux-image-6.4.3-lqx1-kona"
  fi
  [ -z "$kernel" ] && exit
  if [ ! -z "$(dpkg -l|grep "ii  $kernel")" ]; then
    zenity --warning --title="高音質カーネルインストーラー" --text="$kernelnameカーネルはすでにインストールされています" --no-wrap
  else
    if [ "$kernel" = "xenomai4" ] || [ "$kernel" = "xenomai" ] || [ "$kernel" = "kona" ]; then
      if [ -z "$(grep avx /proc/cpuinfo)" ]; then
        zenity --warning --title="高音質カーネルインストーラー" --text="このCPUにはインストールできません" --no-wrap
        exit
      fi
    fi
    echo $kernel > /etc/konahqss/kernel
    pkexec env DISPLAY=$DISPLAY XAUTHORITY=$XAUTHORITY x-terminal-emulator -e /etc/konahqss/installkernel.sh
    if [ ! -z "$(dpkg -l|grep "ii  $kernel")" ]; then
      zenity --info --title="高音質カーネルインストール" --text="$kernelnameカーネルをインストールしました" --no-wrap
    fi
  fi
fi
