#!/bin/bash

. /etc/konahqss/konahqss.inc

arch=$(getarch)

if [ ! -z "$(pgrep bluetoothd)" ] && [ ! -z "$(which systemctl 2> /dev/null)" ]; then
  systemctl restart bluetooth
fi

lib="libasound.so.2.0.0"
libs=$(getlibs $lib)
if [ ! -z "$libs" ] && [ -f $libs/$lib ]; then
  echo $libs > /etc/konahqss/libs
fi
rm -f /etc/konahqss/hqdriveready
rm -f /etc/konahqss/hqdriveready2
rm -f /etc/konahqss/hqusbready
if [ "$(getconf LONG_BIT)" = "64" ] && [ -z "$(echo $libs|grep aarch64)" ]; then
  if [ -f /etc/konahqss/fastmemcpy ] && [ -f /etc/konahqss/soundrivers/$(uname -r)/snd-pcm-avx.ko ]; then
    if [ ! -f /lib/modules/$(uname -r)/kernel/sound/core/snd-pcm.ko.org ]; then
      cp /lib/modules/$(uname -r)/kernel/sound/core/snd-pcm.ko /lib/modules/$(uname -r)/kernel/sound/core/snd-pcm.ko.org
      if [ ! -z "$(grep avx /proc/cpuinfo)" ]; then
        cp /etc/konahqss/soundrivers/$(uname -r)/snd-pcm-avx.ko /lib/modules/$(uname -r)/kernel/sound/core/snd-pcm.ko
      elif [ ! -z "$(grep sse2 /proc/cpuinfo)" ]; then
        cp /etc/konahqss/soundrivers/$(uname -r)/snd-pcm-sse2.ko /lib/modules/$(uname -r)/kernel/sound/core/snd-pcm.ko
      fi
    fi
  else
    if [ -f /lib/modules/$(uname -r)/kernel/sound/core/snd-pcm.ko.org ]; then
      mv /lib/modules/$(uname -r)/kernel/sound/core/snd-pcm.ko.org /lib/modules/$(uname -r)/kernel/sound/core/snd-pcm.ko 
    fi
  fi
  if [ -f /etc/konahqss/fastmemcpy2 ] && [ -f /etc/konahqss/soundrivers/$(uname -r)/snd-avx.ko ]; then
    if [ ! -f /lib/modules/$(uname -r)/kernel/sound/core/snd.ko.org ]; then
      cp /lib/modules/$(uname -r)/kernel/sound/core/snd.ko /lib/modules/$(uname -r)/kernel/sound/core/snd.ko.org
      if [ ! -z "$(grep avx /proc/cpuinfo)" ]; then
        cp /etc/konahqss/soundrivers/$(uname -r)/snd-avx.ko /lib/modules/$(uname -r)/kernel/sound/core/snd.ko
      elif [ ! -z "$(grep sse2 /proc/cpuinfo)" ]; then
        cp /etc/konahqss/soundrivers/$(uname -r)/snd-sse2.ko /lib/modules/$(uname -r)/kernel/sound/core/snd.ko
      fi
    fi
  else
    if [ -f /lib/modules/$(uname -r)/kernel/sound/core/snd.ko.org ]; then
      mv /lib/modules/$(uname -r)/kernel/sound/core/snd.ko.org /lib/modules/$(uname -r)/kernel/sound/core/snd.ko 
      mv /lib/modules/$(uname -r)/kernel/sound/core/snd-pcm.ko.org /lib/modules/$(uname -r)/kernel/sound/core/snd-pcm.ko 
    fi
  fi
  if [ -f /etc/konahqss/hqusbaudio ] && [ -f /etc/konahqss/soundrivers/$(uname -r)/snd-usb-audio-avx.ko ]; then
    if [ ! -f /lib/modules/$(uname -r)/kernel/sound/usb/snd-usb-audio.ko.org ]; then
      cp /lib/modules/$(uname -r)/kernel/sound/usb/snd-usb-audio.ko /lib/modules/$(uname -r)/kernel/sound/usb/snd-usb-audio.ko.org
      if [ ! -z "$(grep avx /proc/cpuinfo)" ]; then
        cp /etc/konahqss/soundrivers/$(uname -r)/snd-usb-audio-avx.ko /lib/modules/$(uname -r)/kernel/sound/usb/snd-usb-audio.ko
      elif [ ! -z "$(grep sse2 /proc/cpuinfo)" ]; then
        cp /etc/konahqss/soundrivers/$(uname -r)/snd-usb-audio-sse2.ko /lib/modules/$(uname -r)/kernel/sound/usb/snd-usb-audio.ko
      fi
    fi
  else
    if [ -f /lib/modules/$(uname -r)/kernel/sound/usb/snd-usb-audio.ko.org ]; then
      mv /lib/modules/$(uname -r)/kernel/sound/usb/snd-usb-audio.ko.org /lib/modules/$(uname -r)/kernel/sound/usb/snd-usb-audio.ko 
    fi
  fi

  if [ ! -f /etc/konahqss/hqdriveready ]; then
    if [ -z "$(modinfo snd-pcm | grep signature:)" ] && [ -f /lib/modules/$(uname -r)/kernel/sound/core/snd-pcm.ko.org ]; then
      touch /etc/konahqss/hqdriveready
    fi
  else
    if [ ! -z "$(modinfo snd-pcm | grep signature:)" ] || [ ! -f /lib/modules/$(uname -r)/kernel/sound/core/snd-pcm.ko.org ]; then
      rm -f /etc/konahqss/hqdriveready
    fi
  fi
  if [ ! -f /etc/konahqss/hqdriveready2 ]; then
    if [ -z "$(modinfo snd | grep signature:)" ] && [ -f /lib/modules/$(uname -r)/kernel/sound/core/snd.ko.org ]; then
      touch /etc/konahqss/hqdriveready2
    fi
  else
    if [ ! -z "$(modinfo snd | grep signature:)" ] || [ ! -f /lib/modules/$(uname -r)/kernel/sound/core/snd.ko.org ]; then
      rm -f /etc/konahqss/hqdriveready2
    fi
  fi
  if [ ! -f /etc/konahqss/hqusbready ]; then
    if [ -z "$(modinfo snd-usb-audio | grep signature:)" ] && [ -f /lib/modules/$(uname -r)/kernel/sound/usb/snd-usb-audio.ko.org ]; then
      touch /etc/konahqss/hqusbready
    fi
  else
    if [ ! -z "$(modinfo snd-usb-audio | grep signature:)" ] || [ ! -f /lib/modules/$(uname -r)/kernel/sound/usb/snd-usb-audio.ko.org ]; then
      rm -f /etc/konahqss/hqusbready
    fi
  fi
fi

# set timeslice / runtime / clocksource
if [ -f /etc/konahqss/timeslice ]; then
  cat /etc/konahqss/timeslice  > /proc/sys/kernel/sched_rr_timeslice_ms
fi

if [ -f /etc/konahqss/runtime ]; then
  cat /etc/konahqss/runtime > /proc/sys/kernel/sched_rt_runtime_us
fi

if [ -f /etc/konahqss/clocksource ]; then
  cat /etc/konahqss/clocksource > /sys/devices/system/clocksource/clocksource0/current_clocksource
fi

# set systemd lib to ram
if [ -f $libs/libsystemd.so.0 ]; then
  lib="$(ls -l $libs/libsystemd.so.0|awk '{print $11}')"
#else
#  lib="$(ls -l $libs/libpulse.so.0|awk '{print $11}')"
fi
if [ -f $libs/$lib ]; then
  if [ ! -z "$(grep low /etc/konahqss/tone)" ] || [ ! -z "$(grep soft /etc/konahqss/mode)" ]; then
    libsetoram $libs/$lib $lib
  fi
fi
#if [ -z "$(which pulseaudio 2> /dev/null)" ] && [ -z "$(which pipewire 2> /dev/null)" ]; then
#  if [ ! -z "$(grep hifi /etc/konahqss/mode)" ]; then
#    lib="libasound.so.2.0.0"
#    refreshfile2 $libs/$lib $lib
#  fi
#fi

#if [ -f /etc/konahqss/ramnotify ]; then
#  /etc/konahqss/setramnotify.sh $libs
#fi

if [ -f /etc/konahqss/baseboost ]; then
  lib="$(ls -l $libs/libupower-glib.so.3|awk '{print $11}')"
  if [ -f $libs/$lib ]; then
    libsetoram $libs/$lib $lib
  else
    lib="$(ls -l $libs/libavahi-core.so.7|awk '{print $11}')"
    if [ -f $libs/$lib ]; then
      libsetoram $libs/$lib $lib
    fi
  fi
fi

# set to ram for jack sound server
#if [ -x /usr/bin/pipewire ] && [ ! -f /etc/konahqss/ramserver ]; then
#  lib="libpipewire-0.3.so.0"
#  libs=$(getlibs $lib)
#  if [ ! -z "$libs" ] && [ -f $libs/$lib ]; then
#    lib=$(ls -l $libs/$lib|awk '{print $11}')
#    libsetoram $libs/$lib $lib
#  fi
#fi
if [ -x /usr/bin/jackd ]; then
  jacklib="libjack.so.0"
  libs=$(getlibs $lib)
  if [ ! -z "$libs" ] && [ -f $libs/$lib ]; then
    lib=$(ls -l $libs/$lib|awk '{print $11}')
    libsetoram $libs/$lib $lib
  fi
fi

rm -f /etc/ld.so.cache
ldconfig
if [ ! -z "$(ldd /usr/bin/yad|grep libsystemd|grep error)" ]; then
  rm $tmp/libsystemd*
  ldconfig
fi

/etc/konahqss/refreshpm.sh $libs

# set TCP read buffer size
#if [ -f /lib/modules/$(uname -r)/kernel/sound/usb/snd-usb-audio.ko.org ]; then
#  echo $((1024 * 32)) > /etc/konahqss/rmem
#else
#  rm -f /etc/konahqss/rmem
#fi
if [ -f /etc/konahqss/rmem ]; then
  minsz=$(cat /proc/sys/net/ipv4/tcp_rmem | awk '{print $1}')
  maxsz=$(cat /proc/sys/net/ipv4/tcp_rmem | awk '{print $3}')
  rmem="$(cat /etc/konahqss/rmem)"
  echo $minsz $rmem $maxsz > /proc/sys/net/ipv4/tcp_rmem
fi

# set server to ram
/etc/konahqss/setramserver.sh

# set player to ram
/etc/konahqss/setplayertoram.sh

# set mtu
if [ -f /etc/konahqss/mtu ]; then
  [ -z "$(ifconfig | grep mtu|grep -v ^lo|cut -d':' -f1)" ] && sleep 10
  ifconfig | grep mtu|grep -v ^lo|cut -d':' -f1 | while read line; do
    ifconfig $line mtu $(cat /etc/konahqss/mtu)
  done
fi

# set pci latency
#/etc/konahqss/setpci.sh > /dev/null

touch /etc/konahqss/soundready
