#!/bin/bash
. /etc/konahqss/konahqss.inc

if [ -x /usr/bin/pulseaudio.save ]; then
  rm -f /usr/bin/pulseaudio
  mv /usr/bin/pulseaudio.save /usr/bin/pulseaudio
fi
if [ -x /usr/bin/pipewire.save ]; then
  rm -f /usr/bin/pipewire
  mv /usr/bin/pipewire.save /usr/bin/pipewire
fi
if [ -f /usr/bin/wireplumber.save ]; then
  rm -f /usr/bin/wireplumber
  mv /usr/bin/wireplumber.save /usr/bin/wireplumber
fi
if [ -f /usr/bin/pipewire-media-session.save ]; then
  rm -f /usr/bin/pipewire-media-session
  mv /usr/bin/pipewire-media-session.save /usr/bin/pipewire-media-session
fi

if [ -L /usr/bin/mpd ] && [ -x /usr/bin/mpd.save ]; then
  rm /usr/bin/mpd
  ln -s /usr/bin/mpd.save /usr/bin/mpd
fi

# refresh drivers
for driver in $(ls /etc/konahqss/drivers.d); do
  /etc/konahqss/drivers.d/$driver
done
if [ -z "$(which pulseaudio 2> /dev/nuu)" ] && [ -z "$(which pipewire 2> /dev/null)" ]; then
  if [ "$(cat /etc/konahqss/mode)" = "hifi" ]; then
    /etc/kona/refreshsound.sh
  fi
fi

rm -f /etc/konahqss/log

libs=$(cat /etc/konahqss/libs)
if [ ! -z $libs ] && [ -f $libs/xfce4/notifyd/xfce4-notifyd.save ]; then
  rm -f $libs/xfce4/notifyd/xfce4-notifyd
  mv $libs/xfce4/notifyd/xfce4-notifyd.save $libs/xfce4/notifyd/xfce4-notifyd
fi
if [ ! -z $libs ] && [ -f $libs/notify-osd.save ]; then
  rm -f $libs/notify-osd
  mv $libs/notify-osd.save $libs/notify-osd
fi
if [ -f /usr/lib/mate-panel/notification-area-applet.save ]; then
  rm -f /usr/lib/mate-panel/notification-area-applet
  mv /usr/lib/mate-panel/notification-area-applet.save /usr/lib/mate-panel/notification-area-applet
fi
if [ -f /usr/bin/gjs.save ]; then
  rm -f /usr/bin/gjs
  mv /usr/bin/gjs.save /usr/bin/gjs
fi
if [ -f /usr/libexec/csd-print-notifications.save ]; then
  rm -f /usr/libexec/csd-print-notifications
  mv /usr/libexec/csd-print-notifications.save /usr/libexec/csd-print-notifications
fi
if [ -f /usr/bin/akonadi_newmailnotifier_agent.save ]; then
  rm -f /usr/bin/akonadi_newmailnotifier_agent
  mv /usr/bin/akonadi_newmailnotifier_agent.save /usr/bin/akonadi_newmailnotifier_agent
fi
if [ -f /usr/libexec/evolution-data-server/evolution-alarm-notify.save ]; then
  rm -f /usr/libexec/evolution-data-server/evolution-alarm-notify
  mv /usr/libexec/evolution-data-server/evolution-alarm-notify.save /usr/libexec/evolution-data-server/evolution-alarm-notify
fi

