#!/bin/bash

soundreadymsg() {
if [ ! -z "$(locale|grep ja_JP)" ]; then
  msg1="オーディオシステムの準備ができました\n\n"
  msg2="　モード：$(cat /etc/konahqss/mode)\n" 
  msg3="　ジャンル：$(cat /etc/konahqss/janru)\n"
  if [ -f /etc/konahqss/hqdriveready ]; then
    msg4="　高音質サウンドドライバー：動作中"
    if [ -f /etc/konahqss/hqdriveready2 ]; then
      if [ ! -f /etc/konahqss/hqusbready ]; then
        msg4="　高音質サウンドドライバー(レベル-2)：動作中"
      else
        msg4="　高音質サウンドドライバー(レベル-2+usbaudio)：動作中"
      fi
    fi
  elif [ -f /etc/konahqss/hqusbready ]; then
    msg4="　usbaudio高音質ドライバー：動作中"
  else
    msg4=""
  fi
  msg="$(echo $msg1$msg2$msg3$msg4)"
  if [ ! -z "$(which notify-send 2> /dev/null)" ]; then
    notify-send "オーディオ準備完了" "$msg" -i "audio-speakers"
    sleep 5
  else
    zenity --info --title="オーディオ準備完了" --text="$msg" --no-wrap --timeout=8
  fi
else
  msg1="Audio system is ready\n\n"
  msg2="  Mode : $(cat /etc/konahqss/mode)\n" 
  msg3="  Janru : $(cat /etc/konahqss/janru)\n"
  if [ -f /etc/konahqss/hqdriveready ]; then
    msg4="  High quality sound driver : Active"
    if [ -f /etc/konahqss/hqdriveready2 ]; then
      msg4="  High quality sound driver(level-2) : Active"
    fi
  else
    msg4=""
  fi
  msg="$(echo $msg1$msg2$msg3$msg4)"
  if [ ! -z "$(which notify-send 2> /dev/null)" ]; then
    notify-send "Audio Ready" "$msg" -i "audio-speakers"
    sleep 5
  else
    zenity --info --title="Audio Ready" --text="$msg" --no-wrap --timeout=8
  fi
fi
}

sleep 10

/etc/konahqss/gethqsdriver.sh

cnt=0
while [ ! -f /etc/konahqss/soundready ]; do
  sleep 1
  cnt=$(($cnt+1))
  if [ $cnt -gt 20 ]; then
    exit
  fi
done
rm -f /etc/konahqss/soundready

if [ -z "$(grep ^normal /etc/konahqss/mode)" ] && [ -z "$(cat /etc/konahqss/mode)" != "soft" ]; then
  soundreadymsg
  exit
fi
#if [ -z "$(which systemctl 2> /dev/null)" ]; then
#  soundreadymsg
#  exit
#fi

if [ -z "$(pgrep pulseaudio)" ] && [ -z "$(pgrep pipewire)" ]; then
  soundreadymsg
  exit
fi

if [ ! -z "$(pgrep pulseaudio)" ]; then
  if [ ! -z "$(which systemctl 2> /dev/null)" ]; then
    systemctl --user restart pulseaudio
    echo "Restart pulseaudio" >> /etc/konahqss/log
  else
    killall pulseaudio
    echo kill pulseaudio >> /etc/konahqss/log
  fi
elif [ ! -z "$(pgrep pipewire)" ]; then
  if [ ! -z "$(which systemctl 2> /dev/null)" ]; then
    systemctl --user restart pipewire
    echo "Restart pipewire" >> /etc/konahqss/log
  else
    killall pipewire
    echo kill pipewire >> /etc/konahqss/log
  fi
fi
soundreadymsg
if [ -z "$(pgrep pulseaudio)" ] && [ -z "$(pgrep pipewire)" ]; then
  if [ ! -z "$(locale|grep ja_JP)" ]; then
    zenity --warning --title="サーバー再起動" --text="再ログインしてください" --no-wrap
  else
    zenity --warning --title="Restart sound server" --text="Please login again" --no-wrap
  fi
fi


