#!/bin/bash
. /etc/konahqss/konahqss.inc

timeslices="10!20!25!50!100"
tones="medium!low!high!highlow" 
janrus="all!jazz!rock!classic!anison!edm!hard rock!heavy metal!live"
modes="normal!soft!hifi!hifi(soft)!direct"
modes2="hifi!hifi(soft)!soft"
hqdrivers="off!level-1!level-2!usbaudio!level-2+usbaudio"

timeslice=$(cat /etc/konahqss/timeslice)
if [ ! -f /etc/konahqss/janru ]; then
  janru="all"
  tone="medium"
else
  janru=$(cat /etc/konahqss/janru)
  tone=$(cat /etc/konahqss/tone)
fi
if [ -f /etc/konahqss/ramplayer ]; then
  ramplayer="TRUE"
else
  ramplayer="FALSE"
fi
if [ -f /etc/konahqss/fastmemcpy ]; then
  hqsound="level-1"
  if [ -f /etc/konahqss/fastmemcpy2 ]; then
    hqsound="level-2"
    if [ -f /etc/konahqss/hqusbaudio ]; then
      hqsound="level-2+usbaudio"
    fi
  fi
elif [ -f /etc/konahqss/hqusbaudio ]; then
   hqsound="usbaudio"
else
  hqsound="off"
fi
if [ ! -z "$(which pulseaudio 2> /dev/null)" ] || [ ! -z "$(which pipewire 2> /dev/null)" ]; then
  initmode="normal"
  if [ ! -z "$(which systemctl 2> /dev/null)" ]; then
    modenable="1"
  else
    modenable="2"
  fi
else
  modes=$modes2
  if [ ! -z "$(which systemctl 2> /dev/null)" ]; then
    modenable="3"
    initmode="soft"
  else
    initmode="hifi"
  fi  
fi
if [ ! -f /etc/konahqss/mode ]; then
  mode="$initmode"
else
  mode=$(cat /etc/konahqss/mode)
fi
if [ -d /etc/konahqss/soundrivers/$(uname -r) ]; then
  if [ -f /lib/modules/$(uname -r)/kernel/sound/core/snd-pcm.ko.org ]; then
    if [ ! -z "$(locale|grep ja_JP)" ]; then
      if [ -f /etc/konahqss/hqdriveready ]; then
        using="(動作中)"
      else
        using="(使用中)"
      fi
    else
      using="(used)"
    fi
  fi
  if [ ! -z "$(locale|grep ja_JP)" ]; then
    ret=$(yad --form --center --title="サウンドの設定" --text="好みのサウンドに設定します\n" --image=/usr/share/pixmaps/sonata.png --field="ジャンル(all):CB" --field="プレイヤーをメモリーに置く:CHK" --field="高音質サウンドドライバー$using:CB" --field="モード:CB" "$janru!$janrus" "$ramplayer" "$hqsound!$hqdrivers" "$mode!$modes")
  else
    ret=$(yad --form --center --title="Sound Settings" --text="Set to your favorite sound\n" --image=/usr/share/pixmaps/sonata.png  --field="Janru(all):CB" --field="Put the server in RAM" --field="Use High Quality Sound Driver:CB" --field="Mode:CB" "$janru!$janrus" "$ramplayer" "$hqsound!$hqdrivers" "$mode!$modes")
  fi
else
  if [ ! -z "$(locale|grep ja_JP)" ]; then
    ret=$(yad --form --center --title="サウンドの設定" --text="好みのサウンドに設定します\n" --image=/usr/share/pixmaps/sonata.png --field="ジャンル(all):CB" --field="プレイヤーをメモリーに置く:CHK" --field="モード:CB" "$janru!$janrus" "$ramplayer" "$mode!$modes")
  else
    ret=$(yad --form --center --title="Sound Settings" --text="Set to your favorite sound\n" --image=/usr/share/pixmaps/sonata.png  --field="Janru(all):CB" --field="Put the player in RAM:CHK" --field="mode:CB" "$janru!$janrus" "$ramplayer" "$mode!$modes")
  fi
fi
rcd="$?"
if [ "$rcd" = "0" ]; then
  janru=$(echo $ret|cut -d'|' -f1)
  case $janru in
    "all") tone="medium";;
    "jazz") tone="medium"
	    baseboost="true";;
    "classic") tone="low";;
    "live") tone="highlow";;
    "anison") tone="high";;
    "edm" | "rock") tone="high"
            baseboost="true";;
    "hard rock") tone="highlow"
            baseboost="true";;
    "heavy metal") tone="low"
            baseboost="true";;
  esac
  echo $tone > /etc/konahqss/tone
  if [ ! -z "$(echo tone|grep low)" ]; then
    echo 8192 > /etc/konahqss/rmem
  else
    rm -f /etc/konahqss/rmem
  fi
  echo $janru > /etc/konahqss/janru
  if [ "$baseboost" = "true" ]; then
    touch /etc/konahqss/baseboost
  else
    rm -f /etc/konahqss/baseboost
  fi
  if [ "$(echo $ret|cut -d'|' -f2)" = "TRUE" ]; then
    touch /etc/konahqss/ramplayer
  else
    rm -f /etc/konahqss/ramplayer
  fi
  if [ -d /etc/konahqss/soundrivers/$(uname -r) ]; then
    if [ "$(echo $ret|cut -d'|' -f3)" != "off" ]; then
      touch /etc/konahqss/fastmemcpy
      rm -f /etc/konahqss/hqusbaudio
      if [ "$(echo $ret|cut -d'|' -f3)" = "level-2" ]; then
        touch /etc/konahqss/fastmemcpy2
      elif [ "$(echo $ret|cut -d'|' -f3)" = "level-1" ]; then
        rm -f /etc/konahqss/fastmemcpy2
      elif [ "$(echo $ret|cut -d'|' -f3)" = "usbaudio" ]; then
        rm -f /etc/konahqss/fastmemcpy /etc/konahqss/fastmemcpy2 
        touch /etc/konahqss/hqusbaudio
      else
        touch /etc/konahqss/fastmemcpy2
        touch /etc/konahqss/hqusbaudio
      fi
#      if [ "$hqsound" = "off" ]; then
      if [ ! -z "$(locale|grep ja_JP)" ]; then
        zenity --warning --title="サウンドの設定" --text="高音質サウンドドライバーを使うときは\nセキュアブートをオフにしてください" --no-wrap
        if [ -f /etc/konahqss/hqusbaudio ] && [ -z "$(lsmod|grep snd_usb_audio)" ]; then
          zenity --warning --title="サウンドの設定" --text="USBにオーディオ機器を接続していないときは\nusbaudio(高音質USBサウンドドライバー)は無効です" --no-wrap
        fi
      else
        zenity --warning --title="Sound Settings" --text="Turn off secure boot when using high quality sound drivers" --no-wrap
      fi
#      fi
    else
      rm -f /etc/konahqss/fastmemcpy
      rm -f /etc/konahqss/fastmemcpy2
      rm -f /etc/konahqss/hqusbaudio
    fi
    mode=$(echo $ret|cut -d'|' -f4)
  else
    mode=$(echo $ret|cut -d'|' -f3)
  fi
  if [ "$modenable" = "2" ]; then
    if [ "$mode" = "normal" ]; then
      if [ ! -z "$(locale|grep ja_JP)" ]; then
        zenity --warning --title="サウンドの設定" --text="Pulseaudioのautospawnが働くときは問題ありませんが\nそうでないときは音が出なくなります\nそのときは再ログインしてください" --no-wrap
      else
        zenity --warning --title="Sound settings" --text=" When Pulseaudio's autospawn works, there is no problem,\nbut when it doesn't, there is no sound.\nIn that case, please log in again" --no-wrap
      fi
    fi
  fi
  if [ ! -z "$mode" ]; then
    echo $mode > /etc/konahqss/mode
  fi
  if [ ! -z "$(locale|grep ja_JP)" ]; then
    zenity --info --title="サウンドの設定" --text="サウンドを設定しました\nシステムを再起動すると有効になります。" --no-wrap
  else
    zenity --info --title="Sound Settings" --text="Completed setting the sound\nIt will take effect when the system is restarted" --no-wrap
  fi
fi

